#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "warpi.h"
#include "wvarpi.h"
#include "wwork.h"
#include "types.h"


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    //
    widht = ui->gView->width();
    height = ui->gView->height();
    //
    rszx    = 640;
    rszy    = 480;
    //
    setx    = _centre_xregion;
    sety    = _centre_yregion;
    //
    scene               = new QGraphicsScene();
    pix                 = new QPixmap(widht,height);
    paint               = new QPainter(pix);
    paint->setWindow(0,0,rszx,rszy);
    //
    ui->gView->setHorizontalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
    ui->gView->setVerticalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
    //
    int  cnt1, cnt2;
    //
    //
    ui->gView->setScene(scene);
    scene->addPixmap(*pix);
    //
    cnt1 = 0;
    while(cnt1 < rszy)
    {
        cnt2 = 0;
        while(cnt2 < rszx)
        {
            dpix[cnt2][cnt1] = 0;
            cnt2++;
        }
        cnt1++;
    }
    //
    valm1       = 0;
    valm2       = 0;
    valm3       = 0;
    valm4       = 0;
    wrvalm1     = 0;
    wrvalm2     = 0;
    wrvalm3     = 0;
    wrvalm4     = 0;
    wrhcam      = 0;
    wrvcam      = 0;
    hcam        = 0;
    vcam        = 0;
    hcamold     = 0;
    vcamold     = 0;
    connected   =   false;
    vconnected  =   false;
    infmode     =   1;
    cmd         = _cmd_stop;
    //
    //histsearch.serch_end    = true;
    //
    //fmat1.mat1x1  =   0;
    //fmat1.mat1y1  =   0;
    //fmat1.mat1x2  =   0;
    //fmat1.mat1y2  =   0;
    //fmat1.mat1x3  =   0;
    //fmat1.mat1y3  =   0;
    //fmat1.mat1x4  =   0;
    //fmat1.mat1y4  =   0;
    //
    //
    ui->strIP->setText(_def_ip);
    ui->strPort->setText("8971");
    ui->vstrIP->setText(_def_ip);
    ui->vstrPort->setText("8998");
    //
    tmr = new QTimer(this); // Создаем объект класса QTimer и передаем адрес переменной
    tmr->setInterval(500); // Задаем интервал таймера
    connect(tmr, SIGNAL(timeout()), this, SLOT(Vals())); // Подключаем сигнал таймера к нашему слоту
    tmr->start(500);//tmr->start(0); // Запускаем таймер
    tmr2 = new QTimer(this); // Создаем объект класса QTimer и передаем адрес переменной
    tmr2->setInterval(5000); // Задаем интервал таймера
    connect(tmr2, SIGNAL(timeout()), this, SLOT(TimerInfo())); // Подключаем сигнал таймера к нашему слоту
    tmr2->start(5000); // Запускаем таймер
    //таймер для поиска
    tmr3 = new QTimer(this); // Создаем объект класса QTimer и передаем адрес переменной
    tmr3->setInterval(500); // Задаем интервал таймера
    connect(tmr3, SIGNAL(timeout()), this, SLOT(Search())); // Подключаем сигнал таймера к нашему слоту
    tmr3->start(500); // Запускаем таймер
    //
    StartWork();
    //
    //wsStartHist(_hist_region_x, _hist_region_y, 0.01);
    //verr = ui->slvalerr->value();
    //wStartHist(_centre_xregion,_centre_yregion);
    //while(!(hist.work));
    //wsStartHist(hist.startx, hist.starty, ui->slvalerr->value());
    //while(!(histsearch.serch_end));
    histregion.startx = 320;
    histregion.starty = 240;
    histsearch.stopx = 320;
    histsearch.stopy = 240;
}

MainWindow::~MainWindow()
{
    delete ui;
}


//вывод камеры в окно
void MainWindow::CamScreen(void)
{
    int x,y;
    y = 0;
    while(y < rszy)
    {
        x = 0;
        while(x < rszx)
        {
            paint->setPen(QColor((dpix[x][y]),0,0));
            paint->drawPoint(x,y);
            x++;
        }
        y++;
    }
}

//вывод гистограммы
void MainWindow::HistScreen(void)
{
    int cnt;
    int wx, wy;
    float hmax;
    float hscale;
    //максимум
    cnt    = 0;
    hmax   = 0;
    while(cnt < _hist_size)
    {
        if(hmax < (float)(hist.hist[cnt]))
            hmax = (float)(hist.hist[cnt]);
        if(hmax < (float)(histregion.hist[cnt]))
            hmax = (float)(histregion.hist[cnt]);
        cnt++;
    }
    if(hmax > 0)
        hscale = (float)(_hist_size_xy) / hmax;
    else
        hscale = 0;
    //центр экрана
    paint->setBrush(QBrush(Qt::color0, Qt::NoBrush));
    paint->setPen(QPen(QColor(255,255,255), 1, Qt::DotLine));
    paint->drawLine(_centre_scrx - _centre_sfre, _centre_scry, _centre_scrx - _centre_size, _centre_scry);
    paint->drawLine(_centre_scrx + _centre_sfre, _centre_scry, _centre_scrx + _centre_size, _centre_scry);
    paint->drawLine(_centre_scrx, _centre_scry - _centre_sfre, _centre_scrx, _centre_scry - _centre_size);
    paint->drawLine(_centre_scrx, _centre_scry + _centre_sfre, _centre_scrx, _centre_scry + _centre_size);
    //маркер поиска
    paint->setPen(QPen(QColor(255,255,255), 3, Qt::SolidLine));
    paint->setBrush(QBrush(QColor(255,255,255), Qt::Dense4Pattern));
    paint->drawEllipse(histregion.startx - _srch_sz / 2, histregion.starty - _srch_sz / 2, _srch_sz, _srch_sz);
    //
    paint->setBrush(QBrush(Qt::color0, Qt::NoBrush));
    paint->setPen(QPen(QColor(255,255,255), 1, Qt::DashDotLine));
    paint->drawRect(_hist_xpos_x, _hist_xpos_y, _hist_size_xx, _hist_size_xy);
    //paint->drawRect(_hist_ypos_x, _hist_ypos_y, _hist_size_yx, _hist_size_yy);
    paint->drawText(_hist_xtxt_x, _hist_xtxt_y, QString::number(hmax));
    paint->drawText(_histe_xtxt_x, _histe_xtxt_y, QString::number(histsearch.err));
    //paint->drawText(_histae_xtxt_x, _histae_xtxt_y, QString::number(histsearch.aerr));
    //заполнение гистограмм
    cnt = 0;
    while(cnt < _hist_size)
    {
        wx = (int)(hist.hist[cnt] * hscale);
        if(wx > _hist_size_xy)
            wx = _hist_size_xy;
        paint->setPen(QPen(QColor(255,255,255), 1, Qt::DotLine));
        paint->drawLine(_hist_xpos_x + cnt ,
                        _hist_xpos_y + _hist_size_xy,
                        _hist_xpos_x + cnt,
                        _hist_xpos_y + _hist_size_xy - wx );
        wx = (int)(histregion.hist[cnt] * hscale);
        if(wx > _hist_size_xy)
            wx = _hist_size_xy;
        paint->setPen(QPen(QColor(255,255,255), 1, Qt::SolidLine));
        paint->drawLine(_hist_xpos_x + cnt,
                        _hist_xpos_y + _hist_size_xy,
                        _hist_xpos_x + cnt,
                        _hist_xpos_y + _hist_size_xy - wx );
        cnt++;
    }
}

void MainWindow::paintEvent(QPaintEvent *event)
{
    //
    scene->clear();
    //
    switch(infmode)
    {
        case _caminfo:
            CamScreen();
            //
            paint->setPen(QColor(255,255,255));
            //позиция камеры
            paint->drawText(_pcamx,_pcamy,"CAM POSITION:");
            paint->drawText(_pcamx,_pcamy + _stepstr,"Horisontal \t" + QString::number(hcam));
            paint->drawText(_pcamx,_pcamy + _stepstr * 2,"Vertical \t" + QString::number(vcam));
            //
            paint->setPen(QPen(QColor(255,255,255), 1, Qt::DashDotLine));
            paint->drawLine(_pghx + 50,_pghy + 50 - 55,_pghx + 50,_pghy + 50 + 55);
            paint->drawLine(_pghx + 50 - 55,_pghy + 50,_pghx + 50 + 55, _pghy + 50);
            paint->setPen(QPen(QColor(255,255,255), 1, Qt::DotLine));
            paint->setBrush(QBrush(Qt::color0, Qt::NoBrush));
            paint->drawEllipse(_pghx,_pghy,100,100);
            paint->setPen(QPen(QColor(255,255,255), 3, Qt::SolidLine));
            paint->setBrush(QBrush(QColor(255,255,255), Qt::DiagCrossPattern));
            paint->drawPie(_pghx, _pghy, 100, 100, (67.5 + hcam) * 16, 45 * 16);
            //
            paint->setPen(QPen(QColor(255,255,255), 1, Qt::DashDotLine));
            paint->drawLine(_pgvx + 50,_pgvy + 50 - 55,_pgvx + 50,_pgvy + 50 + 55);
            paint->drawLine(_pgvx + 50 - 55,_pgvy + 50,_pgvx + 50 + 55, _pgvy + 50);
            paint->setPen(QPen(QColor(255,255,255), 1, Qt::DotLine));
            paint->setBrush(QBrush(QColor(255,255,255), Qt::NoBrush));
            paint->drawEllipse(_pgvx,_pgvy,100,100);
            paint->setPen(QPen(QColor(255,255,255), 3, Qt::SolidLine));
            paint->setBrush(QBrush(QColor(255,255,255), Qt::DiagCrossPattern));
            paint->drawPie(_pgvx, _pgvy, 100, 100, (337.5 + vcam) * 16, 45 * 16);
            //
            break;
        case _motorsinfo:
            CamScreen();
            //
            paint->setPen(QColor(255,255,255));
            //состояние приводов
            paint->drawText(_motorsx, _motorsy, "MOTORS:");
            paint->drawText(_motorsx, _motorsy + _stepstr, "M1 \t" + QString::number(valm1));
            paint->drawText(_motorsx, _motorsy + _stepstr * 2, "M2 \t" + QString::number(valm2));
            paint->drawText(_motorsx, _motorsy + _stepstr * 3, "M3 \t" + QString::number(valm3));
            paint->drawText(_motorsx, _motorsy + _stepstr * 4, "M4 \t" + QString::number(valm4));
            break;
        case _regioninfo:
            CamScreen();
            //
            break;
        default:
            CamScreen();
            //
            break;
    }
    paint->setPen(QColor(255,255,255));
    switch(cmd)
    {
        case _cmd_stop:
            paint->drawText(_cmdx, _cmdy, "CMD : STOP");
            break;
        case _cmd_forward:
            paint->drawText(_cmdx, _cmdy, "CMD : FORWARD");
            break;
        case _cmd_backward:
            paint->drawText(_cmdx, _cmdy, "CMD : BACKWARD");
            break;
        case _cmd_left:
            paint->drawText(_cmdx, _cmdy, "CMD : LEFT");
            break;
        case _cmd_right:
            paint->drawText(_cmdx, _cmdy, "CMD : RIGHT");
            break;
        default:
            break;
    }
    //
    //if(searchinfo)
        HistScreen();
    //
    scene->addPixmap(*pix);
    //
}


void MainWindow::Vals(void)
{
    int val;
    //
    if((wCleintStatus() < 1) && (connected))
    {
        wDisconnect();
        connected = false;
    }
    //
    if((wVCleintStatus() < 1) && (vconnected))
    {
        wVDisconnect();
        vconnected = false;
    }
    if(!(vconnected))
    {
        ui->bvConnect->setText("Connect");
        ui->vstrIP->setEnabled(true);
        ui->vstrPort->setEnabled(true);
        //
        memset(&dpix[0][0], 0, 640*480);
    }
    else
    {
        ui->bvConnect->setText("Disconnect");
        ui->vstrIP->setEnabled(false);
        ui->vstrPort->setEnabled(false);
        //чтение с камеры
        wRdCam((unsigned char*)(&dpix[0][0]));
        ui->lvalerr->setText("ValErr=" + QString::number(ui->slvalerr->value()));
        //
        rtmark = rvtmark;
    }
    //
    if(!(connected))
    {
        ui->bConnect->setText("Connect");
        ui->b_stop->setEnabled(false);//test();
        ui->b_forward->setEnabled(false);
        ui->b_backward->setEnabled(false);
        ui->b_left->setEnabled(false);
        ui->b_right->setEnabled(false);
        ui->sl_speed->setEnabled(false);
        ui->strIP->setEnabled(true);
        ui->strPort->setEnabled(true);
        ui->pServNull->setEnabled((false));
        ui->hcam->setEnabled(false);
        ui->vcam->setEnabled(false);
    }
    else
    {
        ui->bConnect->setText("Disconnect");
        ui->b_stop->setEnabled(true);
        ui->b_forward->setEnabled(true);
        ui->b_backward->setEnabled(true);
        ui->b_left->setEnabled(true);
        ui->b_right->setEnabled(true);
        ui->sl_speed->setEnabled(true);
        ui->strIP->setEnabled(false);
        ui->strPort->setEnabled(false);
        ui->pServNull->setEnabled((true));
        ui->hcam->setEnabled(true);
        ui->vcam->setEnabled(true);
        if(!(vconnected))
            rtmark = rctmark;
    }
    //
    switch(cmd)
    {
        case _cmd_forward:
            val = ui->sl_speed->value();
            wrvalm1 = val;
            wrvalm2 = val;
            wrvalm3 = val;
            wrvalm4 = val;
            break;
        case _cmd_backward:
            val = ui->sl_speed->value();
            wrvalm1 = val * (-1);
            wrvalm2 = val * (-1);
            wrvalm3 = val * (-1);
            wrvalm4 = val * (-1);
            break;
        case _cmd_left:
            val = ui->sl_speed->value();
            wrvalm1 = val * (-1);
            wrvalm2 = val;
            wrvalm3 = val * (-1);
            wrvalm4 = val;
            break;
        case _cmd_right:
            val = ui->sl_speed->value();
            wrvalm1 = val;
            wrvalm2 = val * (-1);
            wrvalm3 = val;
            wrvalm4 = val * (-1);
            break;
        default:
            wrvalm1 = 0;
            wrvalm2 = 0;
            wrvalm3 = 0;
            wrvalm4 = 0;
            cmd = _cmd_stop;
            break;
    }
    //
    valm1   = wRdReg(_rnum_vol_m1);
    valm2   = wRdReg(_rnum_vol_m2);
    valm3   = wRdReg(_rnum_vol_m3);
    valm4   = wRdReg(_rnum_vol_m4);
    hcam    = wRdReg(_rnum_pos_s1);
    vcam    = wRdReg(_rnum_pos_s2);
    //
    wWrReg(_num_vol_m1, wrvalm1);
    wWrReg(_num_vol_m2, wrvalm2);
    wWrReg(_num_vol_m3, wrvalm3);
    wWrReg(_num_vol_m4, wrvalm4);
    //
    wrhcam = (ui->hcam->value()) * (-1);
    wrvcam = ui->vcam->value();
    //
    wWrReg(_num_pos_s1, wrhcam);
    wWrReg(_num_pos_s2, wrvcam);
    //
    ui->ltmark->setText(QString::number(rtmark));
    //
    if((hcam != hcamold) || (vcam != vcamold))
        infmode = _caminfo;
    //
    if(hcam >= ui->hcam->maximum())
        cmd = _cmd_left;
    else if(hcam <= ui->hcam->minimum())
        cmd = _cmd_right;
    else
        cmd = cmdold;
    //
    ui->lsetx->setText("SETX=" + QString::number(setx));
    ui->lsety->setText("SETY=" + QString::number(sety));
    //параметры и режимы виде
    wvtype = ui->cB_scr->currentIndex() + 1;
    ap1     = ui->vSap1->value();
    ap2     = ui->vSap2->value();

}

void MainWindow::on_b_forward_clicked()
{
    cmd = _cmd_forward;
    cmdold = _cmd_forward;
}

void MainWindow::on_b_stop_clicked()
{
    cmd = _cmd_stop;
    cmdold = _cmd_stop;
}

void MainWindow::on_b_backward_clicked()
{
    cmd = _cmd_backward;
    cmdold = _cmd_backward;
}

void MainWindow::on_b_left_clicked()
{
    cmd = _cmd_left;
    cmdold = _cmd_left;
}

void MainWindow::on_b_right_clicked()
{
    cmd = _cmd_right;
    cmdold = _cmd_right;
}

//связь с сервером управления
void MainWindow::on_bConnect_clicked()
{
    QString qstrip      = ui->strIP->text();
    QString qstrport    = ui->strPort->text();
    QByteArray arip, arport;
    char * strip;
    char * strport;
    int port;
    int res;
    if(!(connected))
    {
        arip                = qstrip.toAscii().data();
        arport              = qstrport.toAscii().data();
        strip               = arip.data();
        strport             = arport.data();
        //
        port                = atoi(&strport[0]);
        res = wConnect(&strip[0], port);
        if(res == 0)
            connected = true;
    }
    else
    {
        wDisconnect();
        connected = false;
    }
}

void MainWindow::on_pServNull_clicked()
{
    ui->hcam->setValue(0);
    ui->vcam->setValue(0);
}

void MainWindow::on_bvConnect_clicked()
{
    QString qstrip      = ui->vstrIP->text();
    QString qstrport    = ui->vstrPort->text();
    QByteArray arip, arport;
    char * strip;
    char * strport;
    int port;
    int res;
    if(!(vconnected))
    {
        arip                = qstrip.toAscii().data();
        arport              = qstrport.toAscii().data();
        strip               = arip.data();
        strport             = arport.data();
        //
        port                = atoi(&strport[0]);
        res = wVConnect(&strip[0], port);
        if(res == 0)
            vconnected = true;
    }
    else
    {
        wVDisconnect();
        vconnected = false;
    }
}

void MainWindow::TimerInfo(void)
{
    //
    if((hcam != hcamold) || (vcam != vcamold))
    {
        hcamold = hcam;
        vcamold = vcam;
        infmode = _caminfo;
        return;
    }
    //
    if(infmode < _inf_max)
        infmode++;
    else
        infmode = 0;
}

//
void MainWindow::mousePressEvent(QMouseEvent * mouseEvent)
{
    int x,y;
    int verr;
    QPoint globalPos = this->mapToGlobal( mouseEvent->pos() );
    QPoint scenePos = ui->gView->mapFromGlobal( globalPos );
    x = scenePos.x();
    y = scenePos.y();
    if((x >= 0) && (x < widht) && (y >= 0 ) && (y < height))
    {
        setx = x;
        sety = y;
        verr = ui->slvalerr->value();
        wStartHist(x,y);
        wsStartHist(x, y, (float)(verr));
    }
}


void MainWindow::Search(void)
{
    int val, verr;
    //проверка на процксс поиска
    if(!(histsearch.serch_end))
    {
        searchinfo = true;
        return;
    }
    searchinfo = false;
    //return;
    //verr = ui->slvalerr->value();
    //wsStartHist(_centre_xregion, _centre_yregion, histsearch.startx, histsearch.starty, (float)(verr));
    //проверка соединения управления
    if(!(connected))
        return;
    //проверка принадлежности региону
    if(histsearch.region)
        return;
    //проверка окончание позиционирования камеры
    if((ui->hcam->value() == hcam) &&
            (ui->vcam->value() == vcam))
    {
        if(histsearch.stopx > _centre_xregion)
        {
            val = ui->hcam->value() + 1;
            ui->hcam->setValue(val);
        }
        if(histsearch.stopx < _centre_xregion)
        {
            val = ui->hcam->value() - 1;
            ui->hcam->setValue(val);
        }
        if(histsearch.stopy > _centre_yregion)
        {
            val = ui->vcam->value() - 1;
            ui->vcam->setValue(val);
        }
        if(histsearch.stopy < _centre_yregion)
        {
            val = ui->vcam->value() + 1;
            ui->vcam->setValue(val);
        }
    }
    //
    verr = ui->slvalerr->value();
    wsStartHist(hist.startx, hist.starty, (float)(verr));
}

