#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtGui/QPaintEvent>
#include <QTimer>
#include <qgraphicsview.h>
#include <QPainter>

#include <QGraphicsSceneMouseEvent>
//#include "types.h"

#define _def_ip         "192.168.7.1"

#define _cmd_stop       0
#define _cmd_forward    1
#define _cmd_backward   2
#define _cmd_left       3
#define _cmd_right      4
//
#define _stepstr        15
//
#define _caminfo        1
#define _motorsinfo     2
#define _regioninfo     3
#define _inf_max        3
//
#define _pcamx          30
#define _pcamy          30
#define _pghx           30
#define _pghy           100
#define _pgvx           30
#define _pgvy           250
//
#define _motorsx        30
#define _motorsy        30
//
#define _hist_xpos_x    540 - 256 + 70
#define _hist_xpos_y    20
#define _hist_size_xx   255//70//150
#define _hist_size_xy   35
//#define _hist_ypos_x    540
//#define _hist_ypos_y    115
//#define _hist_size_yx   70//150
//#define _hist_size_yy   35
#define _hist_xtxt_x    540     //текст гимстограммы по горизонтали
#define _hist_xtxt_y    70      //текст гимстограммы по горизонтали
#define _histe_xtxt_x   540     //текст ошибки гимстограммы по горизонтали
#define _histe_xtxt_y   85      //текст ошибки гимстограммы по горизонтали
//#define _histae_xtxt_x  540     //текст абсолютной ошибки гимстограммы по горизонтали
//#define _histae_xtxt_y  100      //текст абсолютной ошибки гимстограммы по горизонтали
//#define _hist_ytxt_x    540     //текст гимстограммы по вертикали
//#define _hist_ytxt_y    165     //текст гимстограммы по вертикали
//#define _histe_ytxt_x   540     //текст ошибки гимстограммы по вертикали
//#define _histe_ytxt_y   180     //текст ошибки гимстограммы по вертикали
//#define _histae_ytxt_x  540     //текст абсолютной ошибки гимстограммы по вертикали
//#define _histae_ytxt_y  195     //текст абсолютной ошибки гимстограммы по вертикали
//
#define _centre_scrx    320
#define _centre_scry    240
#define _centre_size    50
#define _centre_sfre    10
//
#define _srch_sz        50
//
#define _cmdx           30
#define _cmdy           450


namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    int     valm1;
    int     valm2;
    int     valm3;
    int     valm4;
    int     wrvalm1;
    int     wrvalm2;
    int     wrvalm3;
    int     wrvalm4;
    int     wrhcam;
    int     wrvcam;
    int     hcam;
    int     vcam;
    int     hcamold;
    int     vcamold;
    int     cmd;
    int     cmdold;
    bool    connected;
    bool    vconnected;
    bool    searchinfo;
    //
    int     widht;
    int     height;
    int     swidht;
    int     sheight;
    uchar   dpix[640][480];
    uchar   drpix[640][480];
    uchar   dmpix[640][480];
    int     infmode;
    int     infcnt;
    int     rtmark;
    //

private slots:
    void on_b_forward_clicked();

    void on_b_stop_clicked();

    void on_b_backward_clicked();

    void on_b_left_clicked();

    void on_b_right_clicked();

    void CamScreen(void);

    void HistScreen(void);

    void paintEvent(QPaintEvent *event);

    void mousePressEvent(QMouseEvent * mouseEvent);

    void Vals(void);

    void TimerInfo(void);

    void Search(void);

    void on_bConnect_clicked();

    void on_pServNull_clicked();

    void on_bvConnect_clicked();

private:
    QTimer *tmr;
    QTimer *tmr2;
    QTimer *tmr3;
    Ui::MainWindow  *ui;
    QGraphicsScene  *scene;
    QGraphicsView   *gView;
    QPixmap         *pix;
    QPainter        *paint;

};

#endif // MAINWINDOW_H
