#ifndef WARPI_H
#define WARPI_H
#include "types.h"

#define	_szbuf                  1024
#define _SOCKET_TIMEOUT_        7000000//7000000 //
#define _conn_sleep             75000//20000//30000


/*
********************
* для всех пакетов *
********************
*/
//начальные адреса пакета
#define _tcp_szl                0x0000          //младший байт размера
#define _tcp_szh                0x0001          //старший байт размера
#define _type                   0x0002          //тип обращения
#define _cop                    0x0003          //код операции
//значения - маски типа пакета
#define _type_tcp_pkt_mask_rd	_bit_0		//данные передаются из модуля обработки клиенту
#define _type_tcp_pkt_mask_wr	_bit_1		//данные принимаются в модуль обработки от клиента
//команда для _cop
#define	_cop_rd                 0x01            //чтение
#define _cop_wr                 0x02            //запись
#define _cop_rdwr               0x03            //чтение-запись

#define _daddr                  0x0004          //начало данных

/*
************************
массив рабочих регистров
************************
*/
#define _cnt_regs       256	//количество регистров
extern I16	rdregs[_cnt_regs];
extern I16	wrregs[_cnt_regs];
//условный маркер веремни
#define _time_mark      0x10
//режим управления
#define _mode_contrl	0x20	//режим управления
#define _mode_ctrl0     0       //управление прямое
#define _mode_ctrl1     1       //управление приближением
//рабочие определения
#define _num_vol_m1     0x30	//номер регистра привода 1
#define _num_vol_m2     0x31	//номер регистра привода 2
#define _num_vol_m3     0x32	//номер регистра привода 3
#define _num_vol_m4     0x33	//номер регистра привода 4
#define _num_pos_s1     0x40	//номер регистра позиции севомашины 1
#define _num_pos_s2     0x41	//номер регистра позиции севомашины 2
#define _num_pos_s3     0x42	//номер регистра позиции севомашины 3
#define _num_pos_s4     0x43	//номер регистра позиции севомашины 4
#define _num_pos_s5     0x44	//номер регистра позиции севомашины 5
#define _num_pos_s6     0x45	//номер регистра позиции севомашины 6
#define _num_pos_s7     0x46	//номер регистра позиции севомашины 7
#define _num_pos_s8     0x47	//номер регистра позиции севомашины 8
#define _num_pos_s9     0x48	//номер регистра позиции севомашины 9
#define _num_pos_s10	0x49	//номер регистра позиции севомашины 10
#define _num_pos_s11	0x4A	//номер регистра позиции севомашины 11
#define _num_pos_s12	0x4B	//номер регистра позиции севомашины 12
#define _num_pos_s13	0x4C	//номер регистра позиции севомашины 13
#define _num_pos_s14	0x4D	//номер регистра позиции севомашины 14
#define _num_pos_s15	0x4E	//номер регистра позиции севомашины 15
#define _num_pos_s16	0x4F	//номер регистра позиции севомашины 16
#define _num_pos_s17	0x50	//номер регистра позиции севомашины 17
#define _num_pos_s18	0x51	//номер регистра позиции севомашины 18
//прочитанные определения
#define _rnum_vol_m1    0x60	//номер регистра привода 1
#define _rnum_vol_m2    0x61	//номер регистра привода 2
#define _rnum_vol_m3    0x62	//номер регистра привода 3
#define _rnum_vol_m4    0x63	//номер регистра привода 4
#define _rnum_pos_s1    0x70	//номер регистра позиции севомашины 1 - горизонталь камеры
#define _rnum_pos_s2    0x71	//номер регистра позиции севомашины 2 - вертикаль камеры
#define _rnum_pos_s3    0x72	//номер регистра позиции севомашины 3
#define _rnum_pos_s4    0x73	//номер регистра позиции севомашины 4
#define _rnum_pos_s5    0x74	//номер регистра позиции севомашины 5
#define _rnum_pos_s6    0x75	//номер регистра позиции севомашины 6
#define _rnum_pos_s7    0x76	//номер регистра позиции севомашины 7
#define _rnum_pos_s8    0x77	//номер регистра позиции севомашины 8
#define _rnum_pos_s9    0x78	//номер регистра позиции севомашины 9
#define _rnum_pos_s10	0x79	//номер регистра позиции севомашины 10
#define _rnum_pos_s11	0x7A	//номер регистра позиции севомашины 11
#define _rnum_pos_s12	0x7B	//номер регистра позиции севомашины 12
#define _rnum_pos_s13	0x7C	//номер регистра позиции севомашины 13
#define _rnum_pos_s14	0x7D	//номер регистра позиции севомашины 14
#define _rnum_pos_s15	0x7E	//номер регистра позиции севомашины 15
#define _rnum_pos_s16	0x7F	//номер регистра позиции севомашины 16
#define _rnum_pos_s17	0x80	//номер регистра позиции севомашины 17
#define _rnum_pos_s18	0x81	//номер регистра позиции севомашины 18


typedef struct _cCLIENT
{
    int			ipport;
    int			socket;
    char		str_ip_url[256];
}cCLIENT;
extern cCLIENT	cclient;
//

extern int rctmark;
//
extern int wConnect(char* ipaddr, int port);
extern int wDisconnect(void);
//чтение значения регистров
extern I16 wRdReg(int numreg);
//запись значения регистров
extern I16 wWrReg(int numreg, I16 val);
//чтение статуса связи
int wCleintStatus(void);

void * client_process(void * pr);


#endif // WARPI_H
