#ifndef WVARPI_H
#define WVARPI_H
#include "types.h"

#define _vsize_buf          (16 + (640 * 480))		//размер буфера для приёма и передачи по TCP
#define _vconn_sleep        250000//100000//75000//25000
#define _SOCKET_TIMEOUT_    7000000//7000000 //

#define _size_tcp           512

/*
 ********************************
 * Работа с картинкой           *
 ********************************
 *
*/

/*
********************
* для всех пакетов *
********************
*/
//начальные адреса пакета
#define _vtcp_szl               0x0000      //младший байт размера
#define _vtype                  0x0004      //тип обращения - выбор режима (картинка и т.п.)
#define _vcop                   0x0005      //код операции (чтение/запись)
#define _vwidht                 0x0006      //ширина в случае работы с картинкой
#define _vheight                0x0008      //высота в случае работы с картинкой
#define _mtime                  0x000A      //маркер времени для синхронизации (2 байта)
//байты с одресами 0x000С...0x000F резервируем для возможного дальнейшего расширения
#define	_ap1                    0x000C		//параметр 1 для адаптивной бинаризации
#define	_ap2                    0x000D		//параметр 2 для адаптивной баниризации
#define _vdaddr                 0x0010      //начало данных
//команда для _vcop - собственно код операции
#define	_vcop_rd                0x01        //чтение (от сервера клиенту) - в случае с картинкой байтовый массив картинки
#define _vcop_wr                0x02        //запись (от клиента серверу) - в случае с картинкой параметры
#define _vcop_rdwr              0x03        //чтение-запись

/*
************************
прямая передача картинки
8 бит
************************
*/
#define _vtype_scr8             0x01        	//тип обращения - указывает, что от OpenCV картинка чёрно-белая 8 бит
#define _vtype_scr_at           0x02            //adaptive
#define _vtype_scr_ap           0x03            //gray & adapt
typedef struct _cvCLIENT
{
    int			ipport;
    int			socket;
    char		str_ip_url[256];
}cvCLIENT;
extern cvCLIENT	vcclient;

extern int rszx;
extern int rszy;
extern int rvtmark;

extern U8 wvtype;
extern U8 ap1;
extern U8 ap2;

extern int wVConnect(char* ipaddr, int port);
extern int wVDisconnect(void);
//чтение статуса связи
extern int wVCleintStatus(void);
//чтение значения регистров
extern I16 wRdCam(U8 * scr);

void*  vclient_process(void * pr);

#endif // WVARPI_H
