#ifndef WORK_H
#define WORK_H
#include "types.h"

#define _sleep_work     5000   //сон рабочего процесса

#define _strtxr         185
#define _strtyr         85
#define _szxr           301
#define _szyr           301
#define _stepr          10
//
#define _sint           0x10
#define _set_matrix_lev 127
//
#define _centre_xregion 320     //центр экрана по x
#define _centre_yregion 240     //цкнтр экрана по y
#define _region_radius  75      //максимальное удаление от центра
#define _size_search    150     //длина внешней стороны квадрата поиска
//
#define _hist_region_x  320     //цент экрана
#define _hist_region_y  240     //цкнтр экрана
#define _hist_size_x    10 //70
#define _hist_size_y    10 //70
#define _hist_size      256

extern int setx;
extern int sety;
//координаты начала региона
extern int strtxr;
extern int strtyr;
//размер региона
extern int szxr;
extern int szyr;
//шаг в регионе
extern int stepr;

//
extern int mat1x1;
extern int mat1y1;
extern int mat1x2;
extern int mat1y2;
extern int mat1x3;
extern int mat1y3;
extern int mat1x4;
extern int mat1y4;

//запуск рабочего потока
extern int StartWork(void);
//подсчёт мин. сред. макс.
void wMathExtr(void);
//
typedef struct _HIST
{
    U32     hist[_hist_size];
    U16     startx;
    U16     starty;
    bool    work;
}HIST;
extern HIST hist;
extern HIST histregion;
extern int     searchx;
extern int     searchy;
//заполнение гистограммы
void Hist(HIST * h);
//
typedef struct _HISTSEARCH
{
    float   kf;   //коэф
    float   seterr;                 //установлкнная допустимая ошибка
    float   err;                    //ошибка
    float   aerr;                   //абсолютная ошибка
    //
    int     x1;
    int     y1;
    int     x2;
    int     y2;
    int     x3;
    int     y3;
    int     x4;
    int     y4;
    //
    int     stopx;
    int     stopy;
    //
    bool    region;                 //допустимое отклонение от цкнтра
    bool    serch_end;              //поиск окончен
    bool    cont;                   //флаг продолжения поиска
}HISTSEARCH;
extern HISTSEARCH histsearch;
//сравнение гистограмм
int wCompareHist(HIST * h1, HIST * h2, HISTSEARCH * hs);
//поиск по гистограмме
int wSearchHist(void);
//рабочий поток
void * wWork_process(void*);
//установка шага региона
//extern int wSetStep(int st);
//чтение региона
//extern int wRdRegion(U8 * region);
//чтение первой матрицы
//extern int wRdMatrix1(U8 * matr1);
//старт заполнения матрицы1
//extern int wStartMatrix1(U16 sx, U16 sy, U8 verr);
//стапр формирования гистограммы
extern int wStartHist(U16 sx, U16 sy);
//установка для поиска
int wsStartHist(U16 x, U16 y, float err);

#endif // WORK_H
